
var tqink = Components.classes["@datagrove.com/ink"].getService(Components.interfaces.iThunderquill);
var inkKey = "";

const inkFocusTypeTextArea = 1;
const inkFocusTypeFile = 2;
const inkFocusTypeInput = 3;

var inkFocusType = 0;
var inkServerAvailable = false;

////////////////////////////////////////////////////
// code for tracking and tagging input scopes
////////////////////////////////////////////////////

function tqInkBlur()
{
	tqink.Blur();
}
function tqInkPopupScopeMenu(key,x,y)
{
	return tqink.PopupScopeMenu(key,x,y);
	//return "Scope Picked:"+key;
}
function tqInkGuessInputScope(isc,href,id,name,label)
{
	return tqink.GuessInputScope(isc,href,id,name,label);
	//return "Scope guessed|"+href+"#"+id + "#" + name;
}
function tqInkLocalInk(fn)
{
	return tqink.LocalInk(fn);
	//return "LocalPathname";
}
function tqInkWebInk(txt)
{
	return tqink.WebInk(txt);
	//return "[img]http://www.datagrove.com/some.gif[/img]"
}

function popupInputScopes()
{
	if (inkFocusType == 0) return;
	var bx = document.getElementById("inkbox-label");
	var bo = bx.boxObject;
	var x = tqInkPopupScopeMenu(inkKey,bo.screenX,bo.screenY);
	if (x!="")
	{
		inkServerAvailable = (x.substr(0,1)=="+");
		bx.label = x.substr(1);
	}
}
function findParentWithId(fe)
{
	try
	{
		while (true)
		{
			fe = fe.parentNode;
			if (fe.getAttribute("id"))
				return fe;
		}
	}
	catch(e)
	{
		dump("Failed findParentWithId\n");
		return fe;
	}
}
function label_for(id)
{
  var labels = document.getElementsByTagName("label");
  for (var i=0;i<labels.length;i++) 
     if (labels[i].htmlFor==id)  return labels[i].textContent;
  return "";
}
function inkFocusedElement()
{
	try
	{
		inkKey = "";
		inkFocusType = 0;
		
		var fe = document.commandDispatcher.focusedElement;
		if (fe==null)
		{
			inkBlur();
			return;
		}
		
		var isc;
		try{ isc = fe.getAttribute("isc"); } catch(e){dump(e);}
		
		var bx = document.getElementById("inkbox-label");
		bx.label = "focusing";		
		var tn = fe.tagName;
				
		var type = fe.getAttribute("type");
		if (type) type = type.toLowerCase();
		
		if (tn=="html:input")
		{
			inkFocusType = inkFocusTypeInput;
			// really we just care about the url bar
			// we need to roll up through the anonymous nodes
			// to find a textbox 
			fe = findParentWithId(fe);
		}
		 if (tn=="INPUT")
		{
			inkFocusType = inkFocusTypeInput;
			if (type=="password")
				isc = "ms:(!IS_PASSWORD)";
			else if (type=="file")
				isc = "ms:(!IS_FILE_FULLFILEPATH)";
			else if (type=="text" || type==null)
			{
				// it might be the anonymous child of a file input
				if (fe.parentNode.tagName == "INPUT")
				{
					var pt = fe.parentNode.type;
					if (pt) pt = pt.toUpperCase();
					if (pt=="FILE")
					{
						isc = "ms:(!IS_FILE_FULLFILEPATH)";
						inkFocusType = inkFocusTypeFile;
					}
				}
			}
		}
		else if (tn=="TEXTAREA")
		{
			inkFocusType = inkFocusTypeTextArea;
		}
		if (inkFocusType == 0)
			inkBlur(); // can't focus on checkbox, etc.
		else
		{
			bx.label="guessing";
			var x = tqInkGuessInputScope(isc,fe.ownerDocument.location.href,fe.id,fe.name,label_for(fe.id));
			// the result of a guess is both an input scope and a key. The key must be fed back to the popup menu
			// request so that it knows what to tag.
			inkServerAvailable = (x.substr(0,1)=='+');
			var pos = x.indexOf("|");
			bx.label  = x.substr(1,pos-1);
			inkKey = x.substr(pos+1);
		}
	}
	catch(e)
	{
		dump("\nCan't inkFocusedElement\n"+e);
	}
}
window.addEventListener("focus",inkFocusedElement,true);

function inkBlur()
{
	var bx = document.getElementById("inkbox-label");
	bx.label = "";
	inkKey = "";
	tqInkBlur();
}
window.addEventListener("blur",inkBlur,true);

